/*
 * xlink.h
 * Paul Messick, Avermetrics, 7/7/11
 */

#ifndef XLINK_H_
#define XLINK_H_

	#define TIMER_DELAY_1us 100
	#define TIMER_DELAY_1ms 100000

	#define CORE0_NODEID 0x0000

	#define XLINK_CONFIG_EN     0x80000000
	#define XLINK_CONFIG_5W     0x40000000
	#define XLINK_CONFIG_2W     0x00000000
	#define XLINK_CONFIG_HELLO  0x01000000
	#define XLINK_CONFIG_RESET  0x00800000
	#define XLINK_CONFIG_ERROR  0x08000000
	#define HAVE_OR_SENT_CREDIT_FLAGS 0x06000000

	#define SSWITCH_REG_LINK_CONTROL 0x22
	#define SSWITCH_REG_LINK_CONFIG 0x82
	#define SSWITCH_REG_STATIC_HEADER 0xA2
	#define SSWITCH_STATIC_FORWARD_EN 0x80000000
	#define SSWITCH_REG_DIRECTION_H 0x0D

	#define LEFT_LINK 0
	#define RIGHT_LINK 1
	#define TRUE 1
	#define FALSE 0
	
	unsigned int ConfigSSwitch(unsigned int link_delay, int fivewire, unsigned int link);
	int HELLO(unsigned int config, int link);
	int NegotiateXlink(streaming chanend ch, unsigned int link, int fivewire, unsigned int link_delay);
	int stchanendToInt(streaming chanend ch);
	void setdNode(streaming chanend c, int targetNode);
	void ConfigStatic(streaming chanend ch, unsigned int link);
	void Wait(unsigned t);
#endif /* XLINK_H_ */
